unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls, System.Math, mp_types, mp_real,
  mp_cmplx, mp_base;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit_c: TLabeledEdit;
    Edit_b: TLabeledEdit;
    Edit_d: TLabeledEdit;
    Edit_a: TLabeledEdit;
    Button1: TButton;
    Label1: TLabel;
    Edit_e: TLabeledEdit;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function quartic_equation_c(a, b, c, d, e: mp_float;  var ansX : array of double): byte;
    function datainput(var a, b, c, d, e: mp_float; var data: array of double): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//------------------------------------------------------------

// f\
// @ʁ@𓚍\
type
  CAns = record
    n: integer;                       // 
    ans: array[0..3] of mp_complex;   // complex(re, im)
  end;

// 𓚍\̂̃Rs[
procedure CAcopy(a: CAns; var b: CAns);
var
  i : integer;
begin
  for i := 0 to 3 do begin
    mpc_copy(a.ans[i], b.ans[i]);
  end;
  b.n := a.n;
end;

// real -> f(r, 0i);
procedure mp_complex_xr_im0(x: mp_float;  var ans: mp_complex);
begin
  mpf_copy(x, ans.re);
  mpf_set0(ans.im);
end;

// {
procedure cbrt(x: mp_float; var ans: mp_float);
begin
  if not s_mpf_is0(x) then mpf_cbrt(x, ans)  // [łȂ痧
                      else mpf_set0(ans);    // [[
end;

// f
procedure ccbrt(x: mp_complex; var ans: mp_complex);
begin
  if mpc_is0(x) then                    // f[
    mpc_set0(ans)                       // 0
  else                                  // [łȂΗ
    mpc_nroot(x, 3, ans);               // ans = x^1/3
end;

// fꎟ̉@
procedure cequation1(a, b: mp_complex; var ans: CAns);
var
  i : integer;
  c : mp_complex;
begin
  mpc_init(c);

  for i := 0 to 3 do
    mpc_set0(ans.ans[i]);              // ans.ans NA

  if mpc_is0(a) then begin             // a[
    ans.n := 0;                        // 𖳂
  end
  else begin                           // a [łȂ
    ans.n := 1;
    mpc_chs(b, c);                     // b EӂɈړ
    mpc_div(c, a, ans.ans[0])          // ans.ans[0] = -b / a
  end;

  mpc_clear(c);
end;

// f񎟎̉@
procedure cequation2(a, b, c: mp_complex; var ans: CAns);
var
  i           : integer;
  ca, cb, cc  : mp_complex;
  d, e        : Mp_float;
  cf, cg      : mp_complex;
begin
  mpc_init5(cf, cg, ca, cb, cc);
  mpf_init2(d, e);

  for i := 0 to 3 do
    mpc_set0(ans.ans[i]);             // ans.ans[i]̃NA

  if mpc_is0(a) then begin            // a [
     Cequation1(b, c, ans);           // fꎟ
  end
  else begin                          // a [łȂ
    mpf_set_int(d, -2);               // -2
    mpf_inv(d, e);                    // -1/2    -0.5
    mp_complex_xr_im0(e, cf);         // (-0.5, 0i)
    mpc_mul(cf, b, cg);               // (-0.5, 0i)b
    mpc_div(cg, a, cb);               // cb = (-0.5, 0i)b / a
    mpc_div(c, a, cc);                // cc = c / a
    mpc_sqr(cb, cf);                  // cb^2
    mpc_sub(cf, cc, cg);              // cb^2 - c/a
    mpc_sqrt(cg, ca);                 // ca = (cb^2 - c/a)
    mpc_add(cb, ca, ans.ans[0]);      // ans.ans[0] = cb + ca
    mpc_sub(cb, ca, ans.ans[1]);      // ans.ans[1] = cb - ca
    ans.n := 2;                       // n = 2
  end;

  mpc_clear5(cf, cg, ca, cb, cc);
  mpf_clear2(d, e);
end;

// Ỏ@
procedure equation3(a, b, c, d: mp_float; var ans: CAns);
var
  w, w2, cA3, cm, cn  : mp_complex;
  ctmp0, ctmp1, ctmp2 : mp_complex;
  A0, B0, C0, A3      : mp_float;
  p, q, p3, q2        : mp_float;
  m, n, md            : mp_float;
  m05, f05, tmp       : mp_float;
begin
  mpc_init4(w, w2, cA3, cm);
  mpc_init4(ctmp0, ctmp1, ctmp2, cn);

  mpf_init4(A0, B0, C0, A3);
  mpf_init4(p, q, p3, q2);
  mpf_init3(m, n, md);
  mpf_init3(m05, f05, tmp);

  if mpf_is0(a) then begin                  // a [Ȃ畡f񎟎̉@
    mp_complex_xr_im0(b, ctmp0);            // (b, 0i)
    mp_complex_xr_im0(c, ctmp1);            // (c, 0i)
    mp_complex_xr_im0(d, ctmp2);            // (d, 0i)
    cequation2(ctmp0, ctmp1, ctmp2, ans)
  end
  else begin
    mpc_set0(ans.ans[3]);                   // ans.ans[3]̃NA

    mpf_div(b, a, A0);                      // A0 = b/a
    mpf_div(c, a, B0);                      // B0 = c/a
    mpf_div(d, a, C0);                      // C0 = d/a
    mpf_set_int(tmp, 2);                    // 2
    mpf_inv(tmp, f05);                      // f05=1/2    0.5
    mpf_chs(f05, m05);                      // m05=-1/2  -0.5

    mpf_set_int(p, 3);                      // 3
    mpf_sqrt(p, q);                         // 3
    mpf_mul(f05, q, tmp);                   // 0.5*3
    mpc_set_mpf(w, m05, tmp);               // w  =(-0.5, 0.5*3i)   f1̎O捪
    mpf_chs(tmp, tmp);                      // -0.5*3
    mpc_set_mpf(w2, m05, tmp);              // w2 = (-0.5, -0.5*3i)  f1̎O捪
    mpf_div_int(A0, 3, A3);                 // A0/3
    mp_complex_xr_im0(A3, cA3);             // cA3 = (A3, 0i)

    mpf_mul(A0, A3, tmp);                   // A0A3
    mpf_sub(B0, tmp, p);                    // p = B0-A0A3

    mpf_expt_int(A3, 3, p3);                // A3^3
    mpf_mul_int(p3, 2, tmp);                // 2A3^3
    mpf_mul(A3, B0, p3);                    // A3B0
    mpf_sub(tmp, p3, q2);                   // 2A3^3- A3B0
    mpf_add(q2, C0, q);                     // q = 2A3^3- A3B0 + C0
    mpf_div_int(p, 3, p3);                  // p3 = p/3
    mpf_mul(m05, q, q2);                    // q2 = q/-2
    mpf_expt_int(q2, 2, f05);               // q2^2
    mpf_expt_int(p3, 3, m05);               // p3^3
    mpf_add(f05, m05, tmp);                 // q2^2 + p3^3

    if s_mpf_is_ge0(tmp) then begin         // q2^2 + p3^3 >= 0 Ȃ
      mpf_sqrt(tmp, md);                    // md = (q2^2 + p3^3)
      mpf_add(q2, md, tmp);                 // q2+md
      cbrt(tmp, m);                         // m = (q2+md)^1/3
      mpf_sub(q2, md, tmp);                 // q2-md
      cbrt(tmp, n);                         // m = (q2-md)^1/3
      mpf_add(m, n, f05);                   // m+n
      mpf_sub(f05, A3, tmp);                // m+n-A3
      mp_complex_xr_im0(tmp, ans.ans[0]);   // ans.ans[0] = (m+n-A3, 0i)
      mp_complex_xr_im0(m, cm);             // (m, cmi)
      mp_complex_xr_im0(n, cn);             // (n, cni)
      mpc_mul(cm, w, ctmp0);                // (m, cmi)w
      mpc_mul(cn, w2, ctmp1);               // (n, cni)w2
      mpc_add(ctmp0, ctmp1, ctmp2);         // (m, cmi)w + (n, cni)w2
      mpc_sub(ctmp2, cA3, ans.ans[1]);      // ans.ans[1] = (m, cmi)w + (n, cni)w2 - cA3
      mpc_mul(cm, w2, ctmp0);               // (m, cmi)w2
      mpc_mul(cn, w, ctmp1);                // (n, cn)w
      mpc_add(ctmp0, ctmp1, ctmp2);         // (m, cmi)w2 + (n, cni)w
      mpc_sub(ctmp2, cA3, ans.ans[2]);      // ans.ans[2] = (m, cmi)w2 + (n, cni)w - cA3
    end
    else begin                              // (q2^2 + p3^3) < 0 Ȃ
      mpf_chs(tmp, tmp);                    // -q2^2 - p3^3
      mpf_sqrt(tmp, md);                    // md = (-q2^2 - p3^3)
      mpc_set_mpf(ctmp0, q2, md);           // (q2, mdi)
      ccbrt(ctmp0, cm);                     // cm = (q2, mdi)^1/3
      mpf_chs(md, md);                      // -md
      mpc_set_mpf(ctmp1, q2, md);           // (q2, -md)
      ccbrt(ctmp1, cn);                     // cn = (q2, -md)^1/3
      mpc_add(cm, cn, ctmp0);               // cm + cn
      mpc_sub(ctmp0, cA3, ans.ans[0]);      // ans.ans[0] = cm + cn - cA3
      mpc_mul(cm, w, ctmp0);                // cm*w
      mpc_mul(cn, w2, ctmp1);               // cn*w2
      mpc_add(ctmp0, ctmp1, ctmp2);         // cm*w + cn*w2
      mpc_sub(ctmp2, cA3, ans.ans[1]);      // ans.ans[1] = cm*w + cn*w2 - cA3
      mpc_mul(cm, w2, ctmp0);               // cm*w2
      mpc_mul(cn, w, ctmp1);                // cn*w
      mpc_add(ctmp0, ctmp1, ctmp2);         // cm*w2 + cn*w
      mpc_sub(ctmp2, cA3, ans.ans[2]);      // ans.ans[2] = cm*w2 + cn*w - cA3
    end;
    ans.n := 3;                             // n = 3
  end;

  mpc_clear4(w, w2, cA3, cm);
  mpc_clear4(ctmp0, ctmp1, ctmp2, cn);

  mpf_clear4(A0, B0, C0, A3);
  mpf_clear4(p, q, p3, q2);
  mpf_clear3(m, n, md);
  mpf_clear3(m05, f05, tmp);
end;

// wl̉@
procedure equation4_sub(A ,B, C: mp_float; var ans: CAns);
var
  i      : integer;
  res, res1, res2 : Cans;
  x1, x2 : mp_complex;
  X, b1, c1, b2, c2: mp_complex;
  ctmp             : mp_complex;
  L, M, N     : mp_float;
  fone, b0, c0, d0, tmp : mp_float;
begin
  for i:= 0 to 3 do
    mpc_init3(res.ans[i], res1.ans[i], res2.ans[i]);
  mpc_init3(x1, x2, X);
  mpc_init4(b1, c1, b2, c2);

  mpf_init3(L, M, N);
  mpf_init4(fone, b0, c0, d0);
  mpf_init(tmp);
  mpf_init2(ctmp.re, ctmp.im);

  mpf_set1(fone);                       // fone = 1
  if mpf_is0(B) then begin              // B=0
    mpc_set1(X);                        // (1, oi)
    mp_complex_xr_im0(A, b1);           // (A, 0i)
    mp_complex_xr_im0(C, c1);           // (c, 0i)

    cequation2(X, b1, c1, res);         // f ̉@(1, A, C)
    mpc_sqrt(res.ans[0], x1);           // x1=res.ans[0]
    mpc_sqrt(res.ans[1], x2);           // x2=res.ans[1]
    mpc_copy(x1, res.ans[0]);           // res.ans[0] = x1
    mpc_chs(x1, res.ans[1]);            // res.ans[1] = -x1
    mpc_copy(x2, res.ans[2]);           // res.ans[2] = x2
    mpc_chs(x2, res.ans[3]);            // res.ans[3] = -x2
    res.n := 4;
    CAcopy(res, ans);
  end
  else begin                            // B=0łȂ
    mpf_chs(A, b0);                     // b0 = chs(A)
    mpf_mul_int(C, 4, c0);              // c0 = 4C
    mpf_mul(c0, A, tmp);                // tmp = 4AC
    mpf_sqr(B, d0);                     // d0 = B * B
    mpf_sub(tmp, d0, d0);               // d0 = 4AC-B^2
    mpf_chs(c0, c0);                    // c0 = -4c
    equation3(fone, b0, c0, d0, res1);  // Ỏ@
    mpf_copy(res1.ans[0].re, L);        // Oŏ̓ ŏ͕̓K[
    mpf_sub(A, L, M);                   // M = A-L
    mpf_mul_int(M, 2, tmp);             // 2M
    mpf_div(B, tmp, N);                 // N = B/(2M)
    mpf_chs(M, M);                      // -M
    mp_complex_xr_im0(M, ctmp);         // (-M,0i)
    mpc_sqrt(ctmp, X);                  // X=(-M,0i)
    mpf_div_int(L, 2, tmp);             // L/2
    mp_complex_xr_im0(tmp, b2);         // (L/2,0i)
    mp_complex_xr_im0(N, c1);           // (N,0i)
    mpc_mul(X, c1, ctmp);               // X(N,0i)
    mpc_sub(b2, ctmp, c1);              // c1 = (L/2,0i) - X(N,0i)
    mpc_add(b2, ctmp, c2);              // c2 = (L/2,0i) + X(N,0i)
    mpc_chs(X, b1);                     // b1 = -X
    mpc_copy(X, b2);                    // b2 = X
    mpc_set1(ctmp);                     // ctmp = (1, 0i)
    cequation2(ctmp, b1, c1, res1);     // f񎟎̉@ (1,b1,c1)
    cequation2(ctmp, b2, c2, res2);     // f񎟎̉@ (1,b2,c2)

    mpc_copy(res2.ans[0], res1.ans[2]); // res1.ans[2] = res2.ans[0]
    mpc_copy(res2.ans[1], res1.ans[3]); // res1.ans[3] = res2.ans[1]
    res1.n := 4;                        // n = 4
    CAcopy(res1, ans);                  // ans = res1
  end;

  for i:= 0 to 3 do
    mpc_clear3(res.ans[i], res1.ans[i], res2.ans[i]);

  mpc_clear3(x1, x2, X);
  mpc_clear4(b1, c1, b2, c2);

  mpf_clear3(L, M, N);
  mpf_clear4(fone, b0, c0, d0);
  mpf_clear(tmp);
  mpf_clear2(ctmp.re, ctmp.im);
end;

// l̉@@O捀x^3̏
procedure equation4sub(a, b, c, d: mp_float; var ans: CAns);
var
  i : integer;
  A0, B0, C0  : mp_float;
  aa, tmp, tmp1, tmp2: mp_float;
  a4  : mp_complex;
  res : CAns;
begin
  mpf_init3(A0, B0, C0);
  mpf_init4(aa, tmp, tmp1, tmp2);
  mpf_init2(a4.re, a4.im);
  for i := 0 to 3 do
    mpc_init(res.ans[i]);

  mpf_sqr(a, aa);                      // a^2
  mpf_div_int(a, 4, tmp);              // a/4
  mp_complex_xr_im0(tmp, a4);          // Ca4
  mpf_div_int(aa, 8, tmp);             // a^2 / 8
  mpf_mul_int(tmp, 3, B0);             // 3/8*a^2
  mpf_sub(b, B0, A0);                  // A0 = b-3/8*a^2
  mpf_mul(tmp, a, C0);                 // a^3/8
  mpf_mul(a, b, tmp);                  // ab
  mpf_div_int(tmp, 2, tmp2);           // ab/2
  mpf_add(c, C0, tmp1);                // c+a^3/8
  mpf_sub(tmp1, tmp2, B0);             // B0 = c+a^3/8-ab/2
  mpf_sqr(aa, tmp);                    // a^4
  mpf_div_int(tmp, 256, tmp1);         // a^4/256
  mpf_mul_int(tmp1, 3, tmp);           // 3/256*a^4
  mpf_mul(aa, b, tmp2);                // a^2b
  mpf_div_int(tmp2, 16, tmp1);         // a^2b/16
  mpf_mul(a, c, C0);                   // ac
  mpf_div_int(C0, 4, tmp2);            // ac/4
  mpf_sub(d, tmp, C0);                 // d-3/256*a^4
  mpf_add(C0, tmp1, tmp);              // d-3/256*a^4+d+a^2b/16
  mpf_sub(tmp, tmp2, C0);              // C0 = d-3/256*a^4+a^2b/16-ac/4

  equation4_sub(A0, B0, C0, res);      // X^4 + A0X^2 + B0^2 + C0 = 0 ɂl̉@
  for i := 0 to 3 do
    mpc_sub(res.ans[i], a4, res.ans[i]);  // res - a4

  CAcopy(res, ans);                    // ans = res

  mpf_clear3(A0, B0, C0);
  mpf_clear4(aa, tmp, tmp1, tmp2);
  mpf_clear2(a4.re, a4.im);
  for i := 0 to 3 do
    mpc_clear(res.ans[i]);
end;

// l̉@
procedure equation4(a, b, c, d, e: mp_float; var ans: CAns);
var
  b0, c0, d0, e0 : mp_float;
begin
  mpf_init4(b0, c0, d0, e0);

  if mpf_is0(a) then                    // a [
    equation3(b, c, d, e, ans)          // Ỏ@
  else begin                            // [łȂ
    mpf_div(b, a, b0);                  // b0 = b / a
    mpf_div(c, a, c0);                  // c0 = c / a
    mpf_div(d, a, d0);                  // d0 = d / a
    mpf_div(e, a, e0);                  // e0 = e / a
    equation4sub(b0, c0, d0, e0, ans);  // l̉@
  end;

  mpf_clear4(b0, c0, d0, e0);
end;

// f@aCx^4 + bCx^3 + cCx^2 + dCx + e ̌vZ
procedure poly4(a, b, c, d, e: mp_float; x: mp_complex; var ans: mp_complex);
var
  xx, xxx, xxxx : mp_complex;
  ar, br, cr, dr, er: mp_complex;
  a0, b0, c0, d0: mp_complex;
begin
  mpc_init3(xx, xxx, xxxx);
  mpc_init5(ar, br, cr, dr, er);
  mpc_init4(a0, b0, c0, d0);

  mpc_mul(x, x, xx);                        // Cx^2
  mpc_mul(xx, x, xxx);                      // Cx^3
  mpc_mul(xx, xx, xxxx);                    // Cx^4
  mp_complex_xr_im0(a, a0);                 // Ca
  mp_complex_xr_im0(b, b0);                 // Cb
  mp_complex_xr_im0(c, c0);                 // Cc
  mp_complex_xr_im0(d, d0);                 // Cd
  mp_complex_xr_im0(e, er);                 // Ce
  mpc_mul(a0, xxxx, ar);                    // CqCx^4
  mpc_mul(b0, xxx, br);                     // CbCx^3
  mpc_mul(c0, xx, cr);                      // CcCx^2
  mpc_mul(d0, x, dr);                       // CdCx
  mpc_add(ar, br, xx);                      // CqCx^4 + CbCx^3
  mpc_add(cr, dr, xxx);                     // CqCx^2 + CbCx
  mpc_add(xx, xxx, xxxx);                   // CqCx^4 + CbCx^3 + CqCx^2 + CbCx
  mpc_add(xxxx, er, ans);                   // CqCx^4 + CbCx^3 + CqCx^2 + CbCx + Ce

  mpc_clear3(xx, xxx, xxxx);
  mpc_clear5(ar, br, cr, dr, er);
  mpc_clear4(a0, b0, c0, d0);
end;

//--------------------------------------------------
// ꎟ񎟎Ol̉@
// ax^4 + bx^3 + cx^2 + dx + e = 0
// ansX double@xn ̒l
// result  [̃tO
//--------------------------------------------------
function TForm1.quartic_equation_c(a, b, c, d, e: mp_float; var ansX: array of double): byte;
const
  YY = 90;
var
  xint        : mp_int;
  xx, lg, lc  : mp_float;
  res         : Cans;                              // ̉
  j, k        : integer;
  rc          : mp_complex;
  x, i        : array[0..3] of mp_float;
  rcr, rci    : array[0..3] of mp_float;
  tout        : string;
  lng         : integer;

  // _50ȉۂ
  procedure roundX(var xir, xx, lg, lc: mp_float; var ii: mp_int);
  begin
    mpf_abs(xir, xx);
    if mpf_is_gt(xx, lc) then exit;                // 10ȏ̏ꍇۂߖ
    mpf_mul(xir, lg, xx);
    mpf_round(xx, ii);
    mpf_set_mpi(xx, ii);
    mpf_div(xx, lg, xir);
  end;

begin
  for j := 0 to 3 do begin
    mpc_init(res.ans[j]);
    mpf_init4(x[j], i[j], rcr[j], rci[j]);
  end;
  mpc_init(rc);
  mp_init(xint);
  mpf_init3(xx, lg, lc);

  result := 0;
  equation4(a, b, c, d, e, res);                                  // lAOAAꎟ̉@
  for j := 0 to res.n - 1 do begin
    poly4(a, b, c, d, e, res.ans[j], rc);                         // \plvZ
    mpf_copy(res.ans[j].re, x[j]);
    mpf_copy(res.ans[j].im, i[j]);
    mpf_copy(rc.re, rcr[j]);
    mpf_copy(rc.im, rci[j]);
  end;

  for j := 0 to res.n - 1 do ansX[j] := mpf_todouble(x[j]);       // x̒ldoubleϊ
  k := 1;
  for j := 0 to res.n - 1 do begin                                // [̓o
    if mpf_is0(i[j]) then result := result or k;                  // ԂlZbg
    K := K * 2;
  end;

  mpf_exp10i(50, lg);                                             // ۂߌZbg
  mpf_exp10i(10, lc);

  for j := 0 to res.n -1 do begin                                 // ۂ߂̎s
    roundX(x[j], xx, lg, lc, xint);
    roundX(i[j], xx, lg, lc, xint);
    roundX(rcr[j], xx, lg, lc, xint);
    roundX(rci[j], xx, lg, lc, xint);
  end;

  if res.n > 0 then begin
    with Memo1.Lines do begin
      if res.n = 4 then Add(' l̉@  f {');
      if res.n = 3 then Add(' Ỏ@ʁ@f {');
      if res.n = 2 then Add(' 񎟕̉@ʁ@f {');
      if res.n = 1 then Add(' ꎟ̉@ʁ@{');
      for j := 0 to  res.n - 1 do begin
        tout:= '  x' + inttostr(j + 1) + '= ' + string(mpf_decimal_alt(x[j], 50));
        lng := length(tout);
        for k := 0 to 61 - lng do tout := tout + ' ';
        tout := tout + string(mpf_decimal_alt(i[j], 50)) + ' i';
        Add(tout);
      end;
      Add('');
      Add(' Z ans = aX^4 + bX^3 + cX^2 + dX + e');
      for j := 0 to  res.n - 1 do begin
        tout := '  X' + intTostr(j + 1) + 'ans= ' + string(mpf_decimal_alt(rcr[j], 50));
        lng := length(tout);
        for k := 0 to 61 - lng do tout := tout + ' ';
        tout := tout + string(mpf_decimal_alt(rci[j], 50)) + ' i';
        Add(tout);
      end;
    end;
  end;

  for j := 0 to 3 do begin
    mpc_clear(res.ans[j]);
    mpf_clear4(x[j], i[j], rcr[j], rci[j]);
  end;
  mpc_clear(rc);
  mp_clear(xint);
  mpf_clear3(xx, lg, lc);
end;

// ̓f[^[
function TForm1.datainput(var a, b, c, d, e: mp_float; var data: array of double): boolean;
var
  ch: integer;
  ansistr: ansistring;
begin
  result := false;
  val(edit_a.Text, data[0], ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_b.Text, data[1], ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_c.Text, data[2], ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_d.Text, data[3], ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  val(edit_e.Text, data[4], ch);
  if ch <> 0 then begin
    application.MessageBox('̒lł͂܂B','', 0);
    exit;
  end;
  // el a`e {֓ǂݍ
  // eLXgmp_floatɕϊ܂   mpf_read_decimal  pansichar@̂ݑΉł
  // doubleǂݍނƕ_ׂ̌łB
  ansistr := ansistring(edit_a.Text);
  mpf_read_decimal(a, pansichar(ansistr));
  ansistr := ansistring(edit_b.Text);
  mpf_read_decimal(b, pansichar(ansistr));
  ansistr := ansistring(edit_c.Text);
  mpf_read_decimal(c, pansichar(ansistr));
  ansistr := ansistring(edit_d.Text);
  mpf_read_decimal(d, pansichar(ansistr));
  ansistr := ansistring(edit_e.Text);
  mpf_read_decimal(e, pansichar(ansistr));
  result := true;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  top  := (screen.Height - height) div 2;
  left := (screen.Width - width) div 2;
  Memo1.Font.Size := 12;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  a, b, c, d, e : mp_float;
  X : array[0..3] of double;
  abcde: array[0..4] of double;
  iflag         : byte;
  i, j, k       : integer;
  lng           : integer;
  tout          : string;
  // result = ax^4 + bx^3 + cx^2 + dx + e
  function poly4d(x: double): double;
  begin
    result := abcde[0] * x * x* x * x + abcde[1] * x * x * x
              + abcde[2] * x * x + abcde[3] * x + abcde[4];
  end;

  // _10ȉۂ
  function roundx(x: double): double;
  var
    ii : int64;
  begin
    if abs(x) < 1E5 then begin              // 5ȏ̏ꍇȂ
      x := x * 1E10;
      ii := round(x);
      result := ii / 1E10;
    end
    else result := x;
  end;

begin
  mpf_init3(a, b, c);
  mpf_init2(d, e);

  if datainput(a, b, c, d, e, abcde) then begin
    Memo1.Clear;
    iflag := quartic_equation_c(a, b, c, d, e, X);                        // ̉@

    Memo1.Lines.Add('');
    Memo1.Lines.Add(' iflag= ' + intTostr(iflag));

    j := 1;
    Memo1.Lines.Add('');
    Memo1.Lines.Add(' Double 8byte@\');
    for i := 0 to 3 do begin
      if (iflag and j) <> 0 then begin
        tout := '  X' + inttostr(i + 1) + '= ' + floatTostr(roundx(X[i]));
        lng := length(tout);
        for K := 0 to 35 - lng do tout := tout + ' ';
        tout := tout + ('X' + inttostr(i + 1) + 'ans= ' + floatTostr(roundx(poly4d(X[i]))));
        Memo1.Lines.Add(tout);
      end;
      j := j * 2;
    end;
  end;

  mpf_clear3(a, b, c);
  mpf_clear2(d, e);
end;

end.
